> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Execute an invoice schedule

POST https://rest.test.zuora.com/v1/invoice-schedules/{scheduleKey}/execute
Content-Type: application/json

Executes an invoice schedule immediately. During the execution, a bill run is created and generates an invoice or a credit memo asynchronously.

When you use this API operation to execute an invoice schedule item, you have the flexibility to decide whether to specify a specific item ID.

* If you specify the unique ID of an invoice schedule item to be executed in the request, the corresponding invoice schedule item is executed.
* If you do not specify the ID of any invoice schedule item in the request, the subscription end date is used as the target date to determine the next pending schedule item to be executed.

A paused invoice schedule and charges inside cannot be automatically executed by Zuora Scheduler or by this "Execute an invoice schedule" API operation. In this case, you can do one of the following:

* Use the Generate billing documents by account ID API operation
* Create a bill run with the target date greater than the next run date of the invoice schedule through UI or API

For more samples, see [Execute invoice schedules](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Billing_Schedule/Billing_Schedule_tutorials/Execute_invoice_schedules).

**Note**: This operation is available only if you have the Billing Schedule feature enabled.

Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/billing-documents/invoice-schedules/post-execute-invoice-schedule

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `scheduleKey` (string, required) — The unique ID or number of the schedule to be executed. For example, 2c92c8955bd63cc1015bd7c151af02ab or IS-0000001.

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects a POSTExecuteInvoiceScheduleRequest.

- `scheduleItemId` (string, optional) — The ID of the invoice schedule item to be executed. The item must be the earliest pending schedule item. If all the invoice schedule items have been processed and credit is needed to be generated, do not specify this field in the request.

## Response

### 200

OK

- `autoEmail` (boolean, optional) — Whether to automatically send an email after Auto-Post is complete.
- `autoPost` (boolean, optional) — Whether to automatically post the bill run after the bill run is created.
- `autoRenewal` (boolean, optional) — Whether to automatically renew auto-renew subscriptions that are up for renewal.
- `batches` (list of string, optional) — A list of the batches of accounts for this bill run. This field cannot exist with the `billRunFilters` field. **Values:** `AllBatches` or Batch*n* where *n* is a number between 1 and 50, for example, `Batch7`.
- `billCycleDay` (string, optional) — The day of the bill cycle, this field is only valid when `batches` is specified. **Values:** - `AllBillCycleDays` or 1 - 31 for an ad-hoc bill run - `AllBillCycleDays` or 1 - 31 or `AsRunDay` for a scheduled bill run
- `billRunFilters` (list of BillRunFilters, optional) — A list of the target account or subscriptions for this bill run. This field cannot exist with the `batches` field.
- `billRunNumber` (string, optional) — The number of bill run.
- `chargeTypeToExclude` (list of enum, optional) — The types of the charges to be excluded from the generation of billing documents.
  - Allowed values: `OneTime`, `Recurring`, `Usage`
- `createdById` (string, optional) — The ID of the user who created the bill run.
- `createdDate` (string, optional) — The date and time when the bill run was created.
- `id` (string, optional) — The unique ID of the bill run.
- `invoiceDate` (date, optional) — The invoice date for this bill run, only valid for ad-hoc bill runs.
- `invoiceDateOffset` (integer, optional) — The offset compared to bill run execution date, only valid for scheduled bill runs.
- `noEmailForZeroAmountInvoice` (boolean, optional) — Whether to suppress emails for invoices with the total amount of zero or not for this bill run after the bill run is complete. **Note**: Do not email invoices with the total amount of zero.
- `organizationLabels` (list of ExecuteInvoiceScheduleBillRunResponseOrganizationLabelsItems, optional) — The organization(s) that the object belongs to. Note: This field is available only when the Multi-Org feature is enabled.
- `scheduledExecutionTime` (string, optional) — The scheduled execution time for a bill run.
- `status` (enum, optional) — The status of the bill run.
  - Allowed values: `Pending`, `Processing`, `Completed`, `Error`, `Canceled`, `Posted`, `PostInProgress`, `CancelInProgress`, `RemoveInProgress`, `Paused`
- `targetDate` (date, optional) — The target date for this bill run, only valid for ad-hoc bill run.
- `targetDateOffset` (integer, optional) — The offset compared to bill run execution date, only valid for scheduled bill run.
- `updatedById` (string, optional) — The ID of the user who updated the bill run.
- `updatedDate` (string, optional) — The date and time when the bill run was updated.

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### BillRunFilters

- `accountId` (string, optional) — The target account of the bill run.
- `filterType` (enum, optional) — The type of the filter to determine whether to create a bill run at the account level or subscription level.
  - Allowed values: `Account`, `Subscription`, `InvoiceSchedule`
- `subscriptionId` (string, optional) — The unique ID of the target subscription belonged to the target account. This field is required if you set the `filterType` field to `Subscription`.

### ExecuteInvoiceScheduleBillRunResponseOrganizationLabelsItems

- `organizationId` (string, optional) — The organization ID.
- `organizationName` (string, optional) — The organization name.

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Request**

```json
{
  "scheduleItemId": "8ad09b7d82b5c62f0182c5cd16944f73"
}
```

**Response**

```json
{
  "autoEmail": false,
  "autoPost": false,
  "autoRenewal": false,
  "billRunFilters": [
    {
      "accountId": "2c9081a03c63c94c013c66688a2c00bf",
      "filterType": "Subscription",
      "subscriptionId": "402882297e387c51017e38a245c313db"
    }
  ],
  "billRunNumber": "BR-00000016",
  "chargeTypeToExclude": [
    "OneTime",
    "Usage"
  ],
  "createdById": "ff808081298c6e5401298c7274a40005",
  "createdDate": "2022-01-24 19:58:27",
  "id": "2c9890077e8a8490017e8bf3a5171a43",
  "invoiceDate": "2020-02-01",
  "noEmailForZeroAmountInvoice": false,
  "status": "Pending",
  "targetDate": "2020-02-01",
  "updatedById": "ff808081298c6e5401298c7274a40005",
  "updatedDate": "2022-01-24 19:58:27",
  "success": true
}
```

**SDK Code**

```python
import requests

url = "https://rest.test.zuora.com/v1/invoice-schedules/scheduleKey/execute"

payload = { "scheduleItemId": "8ad09b7d82b5c62f0182c5cd16944f73" }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://rest.test.zuora.com/v1/invoice-schedules/scheduleKey/execute';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"scheduleItemId":"8ad09b7d82b5c62f0182c5cd16944f73"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/invoice-schedules/scheduleKey/execute"

	payload := strings.NewReader("{\n  \"scheduleItemId\": \"8ad09b7d82b5c62f0182c5cd16944f73\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/invoice-schedules/scheduleKey/execute")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"scheduleItemId\": \"8ad09b7d82b5c62f0182c5cd16944f73\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/v1/invoice-schedules/scheduleKey/execute")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"scheduleItemId\": \"8ad09b7d82b5c62f0182c5cd16944f73\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/v1/invoice-schedules/scheduleKey/execute', [
  'body' => '{
  "scheduleItemId": "8ad09b7d82b5c62f0182c5cd16944f73"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/invoice-schedules/scheduleKey/execute");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"scheduleItemId\": \"8ad09b7d82b5c62f0182c5cd16944f73\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["scheduleItemId": "8ad09b7d82b5c62f0182c5cd16944f73"] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/invoice-schedules/scheduleKey/execute")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```